"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var t = _interopRequireWildcard(require("@babel/types"));

var R = _interopRequireWildcard(require("ramda"));

var _generateCode = _interopRequireDefault(require("./generateCode"));

var _moduleExports = _interopRequireDefault(require("./moduleExports"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function getKey(encoded) {
  if (/[0-9]/.test(encoded[0])) {
    return t.stringLiteral(encoded);
  }

  return t.identifier(encoded);
}

var stringify = function stringify(list) {
  return Object.keys(list).reduce(function (ast, key) {
    var data = list[key];
    var value;

    if (data === null) {
      value = t.nullLiteral();
    } else if (typeof data === 'undefined') {
      value = t.identifier('undefined');
    } else if (typeof data === 'string') {
      value = t.stringLiteral(data);
    } else if (typeof data === 'number') {
      value = t.numericLiteral(data);
    } else if (Array.isArray(data)) {
      value = t.arrayExpression(data.map(function child(d) {
        if (d === null) {
          return t.nullLiteral();
        }

        if (typeof d === 'undefined') {
          return t.identifier('undefined');
        }

        if (typeof d === 'string') {
          return t.stringLiteral(d);
        }

        if (typeof d === 'number') {
          return t.numericLiteral(d);
        }

        if (Array.isArray(d)) {
          return t.arrayExpression(d.map(child));
        }
      }));
    } else if (data === Object(data)) {
      value = t.objectExpression(stringify(data));
    }

    return ast.concat(t.objectProperty(getKey(key), value));
  }, []);
};

var stringifyObject = R.compose(_generateCode["default"], t.program, R.of, _moduleExports["default"], t.objectExpression, stringify);
var _default = stringifyObject;
exports["default"] = _default;